"use strict";
exports.__esModule = true;
exports.useDebounce = void 0;
var tslib_1 = require("tslib");
var react_1 = (0, tslib_1.__importDefault)(require("react"));
function useDebounce(value, delay) {
    var _a = react_1["default"].useState(value), debouncedValue = _a[0], setDebouncedValue = _a[1];
    react_1["default"].useEffect(function () {
        var timer = setTimeout(function () { return setDebouncedValue(value); }, delay || 500);
        return function () {
            clearTimeout(timer);
        };
    }, [value, delay]);
    return debouncedValue;
}
exports.useDebounce = useDebounce;
exports["default"] = useDebounce;
//# sourceMappingURL=useDebounce.js.map