"use strict";
exports.__esModule = true;
exports.withLoader = void 0;
var tslib_1 = require("tslib");
var react_1 = (0, tslib_1.__importDefault)(require("react"));
var withLoader = function (Component, loader) {
    var CachedComponent;
    var LoadedComponent = function (props) {
        var _a, _b, _c, _d, _e, _f;
        var useLoaderArgs = [];
        if (loader.queriesArg) {
            useLoaderArgs.push(loader.queriesArg(props));
        }
        var query = loader.useLoader.apply(loader, useLoaderArgs);
        if (!CachedComponent) {
            CachedComponent = react_1["default"].forwardRef(Component);
        }
        var onLoading = (_a = loader.onLoading) === null || _a === void 0 ? void 0 : _a.call(loader, props);
        var onError = loader.onError
            ? function (error) {
                if (!loader.onError)
                    return react_1["default"].createElement(react_1["default"].Fragment, null);
                return loader.onError(props, error, query);
            }
            : undefined;
        var onSuccess = function (data) { return (react_1["default"].createElement(CachedComponent, (0, tslib_1.__assign)({}, props, { ref: data }))); };
        var whileFetching = loader.whileFetching
            ? {
                prepend: (_c = (_b = loader.whileFetching).prepend) === null || _c === void 0 ? void 0 : _c.call(_b, props, query === null || query === void 0 ? void 0 : query.data),
                append: (_e = (_d = loader.whileFetching).append) === null || _e === void 0 ? void 0 : _e.call(_d, props, query === null || query === void 0 ? void 0 : query.data)
            }
            : undefined;
        var onFetching = (_f = loader === null || loader === void 0 ? void 0 : loader.onFetching) === null || _f === void 0 ? void 0 : _f.call(loader, props, query.data
            ? function () { return onSuccess(query.data); }
            : function () { return react_1["default"].createElement(react_1["default"].Fragment, null); });
        var LoaderComponent = loader.LoaderComponent;
        return (react_1["default"].createElement(LoaderComponent, { onFetching: onFetching, whileFetching: whileFetching, onSuccess: onSuccess, onError: onError, onLoading: onLoading, query: query }));
    };
    return LoadedComponent;
};
exports.withLoader = withLoader;
//# sourceMappingURL=withLoader.js.map