import { __assign, __rest } from "tslib";
import { aggregateToQuery } from "./aggregateToQuery";
import { RTKLoader } from "./RTKLoader";
var mergeConfig = function (original, extended) {
    if (!original)
        return extended;
    return __assign(__assign(__assign({}, original), extended), { deferred: __assign(__assign({}, original.deferred), extended.deferred) });
};
export var createUseLoader = function (createUseLoaderArgs) {
    var useLoader = function () {
        var _a, _b, _c;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var loaderRes = createUseLoaderArgs.useQueries.apply(createUseLoaderArgs, args);
        var queriesList = loaderRes.queries
            ? Object.keys(loaderRes.queries).map(function (key) { return loaderRes.queries[key]; })
            : [];
        var aggregatedQuery = aggregateToQuery(queriesList);
        if ((_b = (_a = createUseLoaderArgs.config) === null || _a === void 0 ? void 0 : _a.deferred) === null || _b === void 0 ? void 0 : _b.shouldThrowError) {
            if (loaderRes.deferredQueries) {
                var deferredQueriesList = Object.keys(loaderRes.deferredQueries).map(function (key) { return loaderRes.deferredQueries[key]; });
                if (deferredQueriesList.some(function (q) { return q.isError; })) {
                    aggregatedQuery.isError = true;
                    aggregatedQuery.error = (_c = deferredQueriesList.find(function (q) { return q.isError; })) === null || _c === void 0 ? void 0 : _c.error;
                }
            }
        }
        if (aggregatedQuery.isSuccess || queriesList.length === 0) {
            var data = createUseLoaderArgs.transform
                ? createUseLoaderArgs.transform(loaderRes)
                : loaderRes;
            return __assign(__assign({}, aggregatedQuery), { isSuccess: true, data: data, currentData: data, originalArgs: args });
        }
        return aggregatedQuery;
    };
    useLoader.original_args = createUseLoaderArgs;
    return useLoader;
};
export var createLoader = function (createLoaderArgs) {
    var _a, _b, _c, _d;
    var useLoader = createUseLoader({
        useQueries: (_a = createLoaderArgs.useQueries) !== null && _a !== void 0 ? _a : (function () { return ({}); }),
        transform: createLoaderArgs.transform,
        config: createLoaderArgs.config
    });
    var loader = {
        useLoader: useLoader,
        onLoading: createLoaderArgs.onLoading,
        onError: createLoaderArgs.onError,
        onFetching: createLoaderArgs.onFetching,
        whileFetching: createLoaderArgs.whileFetching,
        queriesArg: createLoaderArgs.queriesArg,
        config: createLoaderArgs.config,
        LoaderComponent: (_d = (_c = (_b = createLoaderArgs.config) === null || _b === void 0 ? void 0 : _b.loaderComponent) !== null && _c !== void 0 ? _c : createLoaderArgs.loaderComponent) !== null && _d !== void 0 ? _d : RTKLoader,
        extend: function (_a) {
            var _b, _c;
            var useQueries = _a.useQueries, transform = _a.transform, loaderArgs = __rest(_a, ["useQueries", "transform"]);
            var original = this;
            var mergedConfig = mergeConfig((_b = createLoaderArgs.config) !== null && _b !== void 0 ? _b : {}, (_c = original.config) !== null && _c !== void 0 ? _c : {});
            // For backwards support of `loaderComponent
            if (!mergedConfig.loaderComponent &&
                loaderArgs.loaderComponent) {
                mergedConfig.loaderComponent =
                    loaderArgs.loaderComponent;
            }
            var extendedLoader = __assign(__assign(__assign({}, original), loaderArgs), { config: mergedConfig });
            if (useQueries) {
                var newUseLoader = createUseLoader({
                    useQueries: useQueries,
                    transform: transform,
                    config: mergedConfig
                });
                extendedLoader.useLoader = newUseLoader;
            }
            else if (transform) {
                var newUseLoader = createUseLoader({
                    useQueries: extendedLoader.useLoader.original_args.useQueries,
                    transform: transform,
                    config: mergedConfig
                });
                extendedLoader.useLoader = newUseLoader;
            }
            return extendedLoader;
        }
    };
    return loader;
};
//# sourceMappingURL=createLoader.js.map